import pygame
import os
import sys

cache = {}

data_py = os.path.abspath(os.path.dirname(__file__))
data_dir = os.path.normpath(os.path.join(data_py, 'data'))

#  data directory for pyinstaller
if hasattr(sys, "_MEIPASS"):
    data_dir = os.path.join(sys._MEIPASS, 'data')


def full_path(name):
    return os.path.join(data_dir, name)


def loadimage(name):
    if name not in cache:
        cache[name] = pygame.image.load(full_path(name))
    return cache[name]


def loadfont(name, size):
    key = "{}{}".format(name, size)
    if key not in cache:
        cache[key] = pygame.font.Font(full_path(name), size)
    return cache[key]


def loadmusic(name):
    if name not in cache:
        cache[name] = pygame.mixer.music.load(full_path(name))
    return cache[name]


def loadsound(name):
    if name not in cache:
        cache[name] = pygame.mixer.Sound(full_path(name))
    return cache[name]
